## libtgowt 0~git20210124.be23804+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
cmake_policy(SET CMP0076 NEW)
cmake_policy(SET CMP0091 NEW)

set_property(GLOBAL PROPERTY USE_FOLDERS ON)

set(TG_OWT_SPECIAL_TARGET "" CACHE STRING "Use special platform target, like 'macstore' for Mac App Store.")

if (NOT TG_OWT_SPECIAL_TARGET STREQUAL "osx")
    set(CMAKE_OSX_DEPLOYMENT_TARGET 10.12 CACHE STRING "Minimum OS X deployment version" FORCE)
else()
    set(CMAKE_OSX_DEPLOYMENT_TARGET 10.10 CACHE STRING "Minimum OS X deployment version" FORCE)
endif()

if (NOT TG_OWT_SPECIAL_TARGET STREQUAL "")
    set(TG_OWT_PACKAGED_BUILD 0)
else()
    set(TG_OWT_PACKAGED_BUILD 1)
endif()

option(BUILD_SHARED_LIBS "Builds shared libraries instead of static." ${TG_OWT_PACKAGED_BUILD})
option(TG_OWT_USE_PROTOBUF "Use protobuf to generate additional headers. Useful for packaged build." ${BUILD_SHARED_LIBS})

project(tg_owt
    LANGUAGES C CXX ASM
    DESCRIPTION "WebRTC build for Telegram"
    HOMEPAGE_URL "https://github.com/desktop-app/tg_owt.git"
)
set_property(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY VS_STARTUP_PROJECT tg_owt)

get_filename_component(webrtc_loc "src" REALPATH)
set(third_party_loc ${webrtc_loc}/third_party)

include(GNUInstallDirs)
set(webrtc_includedir ${CMAKE_INSTALL_INCLUDEDIR}/tg_owt)

if (CMAKE_OSX_ARCHITECTURES STREQUAL "arm64")
    set(is_aarch64 1)
    set(arm_use_neon 1)
else()
    if(CMAKE_OSX_ARCHITECTURES STREQUAL "x86_64")
        set(is_x64 1)
    else()
        include(cmake/arch.cmake)
    endif()
endif()

include(cmake/nice_target_sources.cmake)
include(cmake/init_target.cmake)
include(cmake/target_yasm_sources.cmake)
include(cmake/external.cmake)
include(cmake/libabsl.cmake)
include(cmake/libopenh264.cmake)
include(cmake/libpffft.cmake)
include(cmake/librnnoise.cmake)
include(cmake/libsrtp.cmake)
include(cmake/libusrsctp.cmake)
include(cmake/libvpx.cmake)
include(cmake/libwebrtcbuild.cmake)
include(cmake/libyuv.cmake)
if (NOT WIN32 AND NOT APPLE)
    include(cmake/libevent.cmake)
endif()
if (APPLE)
    include(cmake/libsdkmacos.cmake)
endif()

# Use a separate subdirectory, because it will be exported as an INTERFACE
# for the generated sources and headers.
if (TG_OWT_USE_PROTOBUF)
    add_subdirectory(cmake/protobuf)
endif()

add_library(tg_owt)
init_target(tg_owt)

set_target_properties(tg_owt PROPERTIES SOVERSION 0 VERSION 0.0.0)

if (is_x86 OR is_x64)
    target_link_libraries(tg_owt
    PUBLIC
        tg_owt::libwebrtcbuild
    PRIVATE
        tg_owt::tg_owt_avx2
        tg_owt::tg_owt_sse2
        tg_owt::libabsl
        tg_owt::libopenh264
        tg_owt::libpffft
        tg_owt::librnnoise
        tg_owt::libsrtp
        tg_owt::libusrsctp
        tg_owt::libvpx
        tg_owt::libvpx_mmx
        tg_owt::libvpx_sse2
        tg_owt::libvpx_ssse3
        tg_owt::libvpx_sse4
        tg_owt::libvpx_avx
        tg_owt::libvpx_avx2
        tg_owt::libyuv
    )
else()
    target_link_libraries(tg_owt
    PUBLIC
        tg_owt::libwebrtcbuild
    PRIVATE
        tg_owt::libabsl
        tg_owt::libopenh264
        tg_owt::libpffft
        tg_owt::librnnoise
        tg_owt::libsrtp
        tg_owt::libusrsctp
        tg_owt::libvpx
        tg_owt::libyuv
    )
endif()

if (TG_OWT_USE_PROTOBUF)
    target_link_libraries(tg_owt
    PRIVATE
        tg_owt::proto
    )
endif()

target_sources(tg_owt
PRIVATE
    ${libvpx_yasm_objects}
    ${libopenh264_yasm_objects}
)

if (NOT WIN32 AND NOT APPLE)
    target_link_libraries(tg_owt PRIVATE tg_owt::libevent)
endif()
if (APPLE)
    target_link_libraries(tg_owt PUBLIC tg_owt::libsdkmacos)
endif()

link_openssl(tg_owt)
link_ffmpeg(tg_owt)
link_opus(tg_owt)

if (UNIX AND NOT APPLE)
    link_libalsa(tg_owt)
    link_libpulse(tg_owt)
    link_dl(tg_owt)
endif()

function(add_sublibrary postfix)
    add_library(tg_owt_${postfix} OBJECT)
    init_feature_target(tg_owt_${postfix} ${postfix})
    add_library(tg_owt::tg_owt_${postfix} ALIAS tg_owt_${postfix})
    target_link_libraries(tg_owt_${postfix}
    PUBLIC
        tg_owt::libwebrtcbuild
    PRIVATE
        tg_owt::libabsl
    )
    target_include_directories(tg_owt_${postfix}
    PUBLIC
        $<BUILD_INTERFACE:${webrtc_loc}>
        $<INSTALL_INTERFACE:${webrtc_includedir}>
    )
    set(sources_list ${ARGV})
    list(REMOVE_AT sources_list 0)
    nice_target_sources(tg_owt_${postfix} ${webrtc_loc}
    PRIVATE
        ${sources_list}
    )
endfunction()

nice_target_sources(tg_owt ${webrtc_loc}
PRIVATE
    rtc_base/deprecated/recursive_critical_section.cc
    rtc_base/deprecated/recursive_critical_section.h
    rtc_base/async_invoker.cc
    rtc_base/async_invoker.h
    rtc_base/async_invoker_inl.h
    rtc_base/async_packet_socket.cc
    rtc_base/async_packet_socket.h
    rtc_base/async_resolver_interface.cc
    rtc_base/async_resolver_interface.h
    rtc_base/async_socket.cc
    rtc_base/async_socket.h
    rtc_base/async_tcp_socket.cc
    rtc_base/async_tcp_socket.h
    rtc_base/async_udp_socket.cc
    rtc_base/async_udp_socket.h
    rtc_base/callback_list.cc
    rtc_base/callback_list.h
    rtc_base/crc32.cc
    rtc_base/crc32.h
    rtc_base/crypt_string.cc
    rtc_base/crypt_string.h
    rtc_base/checks.cc
    rtc_base/checks.h
    # rtc_base/critical_section.cc
    # rtc_base/critical_section.h
    rtc_base/data_rate_limiter.cc
    rtc_base/data_rate_limiter.h
    rtc_base/dscp.h
    rtc_base/file_rotating_stream.cc
    rtc_base/file_rotating_stream.h
    rtc_base/helpers.cc
    rtc_base/helpers.h
    rtc_base/http_common.cc
    rtc_base/http_common.h
    rtc_base/ip_address.cc
    rtc_base/ip_address.h
    rtc_base/logging.cc
    rtc_base/logging.h
    rtc_base/keep_ref_until_done.h
    rtc_base/mdns_responder_interface.h
    rtc_base/memory/aligned_malloc.cc
    rtc_base/memory/aligned_malloc.h
    rtc_base/memory/fifo_buffer.cc
    rtc_base/memory/fifo_buffer.h
    rtc_base/message_digest.cc
    rtc_base/message_digest.h
    rtc_base/message_handler.cc
    rtc_base/message_handler.h
    rtc_base/net_helper.cc
    rtc_base/net_helper.h
    rtc_base/net_helpers.cc
    rtc_base/net_helpers.h
    rtc_base/network/sent_packet.cc
    rtc_base/network/sent_packet.h
    rtc_base/network.cc
    rtc_base/network_route.cc
    rtc_base/network.h
    rtc_base/network_constants.cc
    rtc_base/network_constants.h
    rtc_base/network_monitor.cc
    rtc_base/network_monitor.h
    rtc_base/network_route.h
    rtc_base/null_socket_server.cc
    rtc_base/null_socket_server.h
    rtc_base/platform_thread.cc
    rtc_base/platform_thread.h
    rtc_base/platform_thread_types.cc
    rtc_base/platform_thread_types.h
    rtc_base/operations_chain.cc
    rtc_base/operations_chain.h
    rtc_base/openssl.h
    rtc_base/openssl_adapter.cc
    rtc_base/openssl_adapter.h
    rtc_base/openssl_certificate.cc
    rtc_base/openssl_certificate.h
    rtc_base/openssl_digest.cc
    rtc_base/openssl_digest.h
    rtc_base/openssl_identity.cc
    rtc_base/openssl_identity.h
    rtc_base/openssl_key_pair.cc
    rtc_base/openssl_key_pair.h
    rtc_base/openssl_session_cache.cc
    rtc_base/openssl_session_cache.h
    rtc_base/openssl_stream_adapter.cc
    rtc_base/openssl_stream_adapter.h
    rtc_base/openssl_utility.cc
    rtc_base/openssl_utility.h
    rtc_base/physical_socket_server.cc
    rtc_base/physical_socket_server.h
    rtc_base/proxy_info.cc
    rtc_base/proxy_info.h
    rtc_base/rtc_certificate.cc
    rtc_base/rtc_certificate.h
    rtc_base/rtc_certificate_generator.cc
    rtc_base/rtc_certificate_generator.h
    rtc_base/rate_limiter.cc
    rtc_base/rate_limiter.h
    # rtc_base/signal_thread.cc
    # rtc_base/signal_thread.h
    rtc_base/sigslot_repeater.h
    rtc_base/socket.cc
    rtc_base/socket.h
    rtc_base/socket_adapters.cc
    rtc_base/socket_adapters.h
    rtc_base/socket_address.cc
    rtc_base/socket_address.h
    rtc_base/socket_address_pair.cc
    rtc_base/socket_address_pair.h
    rtc_base/socket_factory.h
    rtc_base/socket_server.h
    rtc_base/ssl_adapter.cc
    rtc_base/ssl_adapter.h
    rtc_base/ssl_certificate.cc
    rtc_base/ssl_certificate.h
    rtc_base/ssl_fingerprint.cc
    rtc_base/ssl_fingerprint.h
    rtc_base/ssl_identity.cc
    rtc_base/ssl_identity.h
    rtc_base/ssl_stream_adapter.cc
    rtc_base/ssl_stream_adapter.h
    rtc_base/stream.cc
    rtc_base/stream.h
    rtc_base/time_utils.cc
    rtc_base/time_utils.h
    rtc_base/thread.cc
    rtc_base/thread.h
    rtc_base/thread_message.h
    rtc_base/unique_id_generator.cc
    rtc_base/unique_id_generator.h
    rtc_base/bind.h
    rtc_base/bit_buffer.cc
    rtc_base/bit_buffer.h
    rtc_base/buffer.h
    rtc_base/buffer_queue.cc
    rtc_base/buffer_queue.h
    rtc_base/byte_buffer.cc
    rtc_base/byte_buffer.h
    rtc_base/byte_order.h
    rtc_base/copy_on_write_buffer.cc
    rtc_base/copy_on_write_buffer.h
    rtc_base/event.cc
    rtc_base/event.h
    rtc_base/event_tracer.cc
    rtc_base/event_tracer.h
    rtc_base/location.cc
    rtc_base/location.h
    rtc_base/message_buffer_reader.h
    rtc_base/numerics/histogram_percentile_counter.cc
    rtc_base/numerics/histogram_percentile_counter.h
    rtc_base/numerics/mod_ops.h
    rtc_base/numerics/moving_max_counter.h
    rtc_base/numerics/sample_counter.cc
    rtc_base/numerics/sample_counter.h
    rtc_base/one_time_event.h
    rtc_base/race_checker.cc
    rtc_base/race_checker.h
    rtc_base/random.cc
    rtc_base/random.h
    rtc_base/rate_statistics.cc
    rtc_base/rate_statistics.h
    rtc_base/rate_tracker.cc
    rtc_base/rate_tracker.h
    rtc_base/swap_queue.h
    rtc_base/timestamp_aligner.cc
    rtc_base/timestamp_aligner.h
    rtc_base/trace_event.h
    rtc_base/zero_memory.cc
    rtc_base/zero_memory.h
    rtc_base/string_encode.cc
    rtc_base/string_encode.h
    rtc_base/string_to_number.cc
    rtc_base/string_to_number.h
    rtc_base/string_utils.cc
    rtc_base/string_utils.h
    rtc_base/weak_ptr.cc
    rtc_base/weak_ptr.h
    rtc_base/win32.cc
    rtc_base/win32.h
    rtc_base/win32_window.cc
    rtc_base/win32_window.h
    rtc_base/win/scoped_com_initializer.cc
    rtc_base/win/scoped_com_initializer.h
    rtc_base/win/windows_version.cc
    rtc_base/win/windows_version.h
    rtc_base/strings/string_builder.cc
    rtc_base/strings/string_builder.h
    rtc_base/strings/string_format.cc
    rtc_base/strings/string_format.h
    # rtc_base/experiments/experimental_screenshare_settings.cc
    # rtc_base/experiments/experimental_screenshare_settings.h
    rtc_base/experiments/alr_experiment.cc
    rtc_base/experiments/balanced_degradation_settings.cc
    rtc_base/experiments/cpu_speed_experiment.cc
    rtc_base/experiments/field_trial_list.cc
    rtc_base/experiments/field_trial_parser.cc
    rtc_base/experiments/field_trial_units.cc
    rtc_base/experiments/jitter_upper_bound_experiment.cc
    rtc_base/experiments/keyframe_interval_settings.cc
    rtc_base/experiments/min_video_bitrate_experiment.cc
    rtc_base/experiments/normalize_simulcast_size_experiment.cc
    rtc_base/experiments/quality_rampup_experiment.cc
    rtc_base/experiments/quality_scaler_settings.cc
    rtc_base/experiments/quality_scaling_experiment.cc
    rtc_base/experiments/rate_control_settings.cc
    rtc_base/experiments/rtt_mult_experiment.cc
    rtc_base/experiments/stable_target_rate_experiment.cc
    rtc_base/experiments/struct_parameters_parser.cc
    rtc_base/numerics/event_based_exponential_moving_average.cc
    rtc_base/numerics/event_rate_counter.cc
    rtc_base/numerics/exp_filter.cc
    rtc_base/numerics/histogram_percentile_counter.cc
    rtc_base/numerics/moving_average.cc
    rtc_base/numerics/sample_counter.cc
    rtc_base/numerics/sample_stats.cc
    # rtc_base/numerics/samples_stats_counter.cc
    rtc_base/strings/audio_format_to_string.cc
    rtc_base/strings/string_builder.cc
    rtc_base/synchronization/mutex.cc
    rtc_base/synchronization/mutex.h
    rtc_base/synchronization/yield.cc
    rtc_base/synchronization/yield.h
    # rtc_base/synchronization/rw_lock_posix.cc

=== src/third_party/abseil-cpp/absl/container/CMakeLists.txt ===
#
# Copyright 2017 The Abseil Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#      https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

# This is deprecated and will be removed in the future.  It also doesn't do
# anything anyways.  Prefer to use the library associated with the API you are
# using.
absl_cc_library(
  NAME
    container
  PUBLIC
)

absl_cc_library(
  NAME
    btree
  HDRS
    "btree_map.h"
    "btree_set.h"
    "internal/btree.h"
    "internal/btree_container.h"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  LINKOPTS
    ${ABSL_DEFAULT_LINKOPTS}
  DEPS
    absl::container_common
    absl::compare
    absl::compressed_tuple
    absl::container_memory
    absl::cord
    absl::core_headers
    absl::layout
    absl::memory
    absl::strings
    absl::throw_delegate
    absl::type_traits
    absl::utility
)

absl_cc_library(
  NAME
    btree_test_common
  hdrs
    "btree_test.h"
  COPTS
    ${ABSL_TEST_COPTS}
  LINKOPTS
    ${ABSL_DEFAULT_LINKOPTS}
  DEPS
    absl::btree
    absl::cord
    absl::flat_hash_set
    absl::strings
    absl::time
  TESTONLY
)

absl_cc_test(
  NAME
    btree_test
  SRCS
    "btree_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  LINKOPTS
    ${ABSL_DEFAULT_LINKOPTS}
  DEPS
    absl::btree
    absl::btree_test_common
    absl::compare
    absl::core_headers
    absl::counting_allocator
    absl::flags
    absl::hash_testing
    absl::raw_logging_internal
    absl::strings
    absl::test_instance_tracker
    absl::type_traits
    gmock_main
)

absl_cc_library(
  NAME
    compressed_tuple
  HDRS
    "internal/compressed_tuple.h"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  DEPS
    absl::utility
  PUBLIC
)

absl_cc_test(
  NAME
    compressed_tuple_test
  SRCS
    "internal/compressed_tuple_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::any
    absl::compressed_tuple
    absl::memory
    absl::optional
    absl::test_instance_tracker
    absl::utility
    gmock_main
)

absl_cc_library(
  NAME
    fixed_array
  HDRS
   "fixed_array.h"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  DEPS
    absl::compressed_tuple
    absl::algorithm
    absl::core_headers
    absl::dynamic_annotations
    absl::throw_delegate
    absl::memory
  PUBLIC
)

absl_cc_test(
  NAME
    fixed_array_test
  SRCS
    "fixed_array_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::fixed_array
    absl::config
    absl::exception_testing
    absl::hash_testing
    absl::memory
    gmock_main
)

absl_cc_test(
  NAME
    fixed_array_exception_safety_test
  SRCS
    "fixed_array_exception_safety_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::fixed_array
    absl::config
    absl::exception_safety_testing
    gmock_main
)

absl_cc_library(
  NAME
    inlined_vector_internal
  HDRS
   "internal/inlined_vector.h"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  DEPS
    absl::compressed_tuple
    absl::core_headers
    absl::memory
    absl::span
    absl::type_traits
  PUBLIC
)

absl_cc_library(
  NAME
    inlined_vector
  HDRS
   "inlined_vector.h"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  DEPS
    absl::algorithm
    absl::core_headers
    absl::inlined_vector_internal
    absl::throw_delegate
    absl::memory
  PUBLIC
)

absl_cc_library(
  NAME
    counting_allocator
  HDRS
    "internal/counting_allocator.h"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  DEPS
    absl::config
)

absl_cc_test(
  NAME
    inlined_vector_test
  SRCS
    "inlined_vector_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::counting_allocator
    absl::inlined_vector
    absl::test_instance_tracker
    absl::config
    absl::core_headers
    absl::exception_testing
    absl::hash_testing
    absl::memory
    absl::raw_logging_internal
    absl::strings
    gmock_main
)

absl_cc_test(
  NAME
    inlined_vector_exception_safety_test
  SRCS
    "inlined_vector_exception_safety_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::inlined_vector
    absl::config
    absl::exception_safety_testing
    gmock_main
)

absl_cc_library(
  NAME
    test_instance_tracker
  HDRS
    "internal/test_instance_tracker.h"
  SRCS
    "internal/test_instance_tracker.cc"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  DEPS
    absl::compare
  TESTONLY
)

absl_cc_test(
  NAME
    test_instance_tracker_test
  SRCS
    "internal/test_instance_tracker_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::test_instance_tracker
    gmock_main
)

absl_cc_library(
  NAME
    flat_hash_map
  HDRS
    "flat_hash_map.h"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  DEPS
    absl::container_memory
    absl::hash_function_defaults
    absl::raw_hash_map
    absl::algorithm_container
    absl::memory
  PUBLIC
)

absl_cc_test(
  NAME
    flat_hash_map_test
  SRCS
    "flat_hash_map_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::flat_hash_map
    absl::hash_generator_testing
    absl::unordered_map_constructor_test
    absl::unordered_map_lookup_test
    absl::unordered_map_members_test
    absl::unordered_map_modifiers_test
    absl::any
    gmock_main
)

absl_cc_library(
  NAME
    flat_hash_set
  HDRS
    "flat_hash_set.h"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  DEPS
    absl::container_memory
    absl::hash_function_defaults
    absl::raw_hash_set
    absl::algorithm_container
    absl::core_headers
    absl::memory
  PUBLIC
)

absl_cc_test(
  NAME
    flat_hash_set_test
  SRCS
    "flat_hash_set_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
    "-DUNORDERED_SET_CXX17"
  DEPS
    absl::flat_hash_set
    absl::hash_generator_testing
    absl::unordered_set_constructor_test
    absl::unordered_set_lookup_test
    absl::unordered_set_members_test
    absl::unordered_set_modifiers_test
    absl::memory
    absl::strings
    gmock_main
)

absl_cc_library(
  NAME
    node_hash_map
  HDRS
    "node_hash_map.h"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  DEPS
    absl::container_memory
    absl::hash_function_defaults
    absl::node_hash_policy
    absl::raw_hash_map
    absl::algorithm_container
    absl::memory
  PUBLIC
)

absl_cc_test(
  NAME
    node_hash_map_test
  SRCS
    "node_hash_map_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::hash_generator_testing
    absl::node_hash_map
    absl::tracked
    absl::unordered_map_constructor_test
    absl::unordered_map_lookup_test
    absl::unordered_map_members_test
    absl::unordered_map_modifiers_test
    gmock_main
)

absl_cc_library(
  NAME
    node_hash_set
  HDRS
    "node_hash_set.h"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  DEPS
    absl::hash_function_defaults
    absl::node_hash_policy
    absl::raw_hash_set
    absl::algorithm_container
    absl::memory
  PUBLIC
)

absl_cc_test(
  NAME
    node_hash_set_test
  SRCS
    "node_hash_set_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
    "-DUNORDERED_SET_CXX17"
  DEPS
    absl::hash_generator_testing
    absl::node_hash_set
    absl::unordered_set_constructor_test
    absl::unordered_set_lookup_test
    absl::unordered_set_members_test
    absl::unordered_set_modifiers_test
    gmock_main
)

absl_cc_library(
  NAME
    container_memory
  HDRS
    "internal/container_memory.h"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  DEPS
    absl::memory
    absl::type_traits
    absl::utility
  PUBLIC
)

absl_cc_test(
  NAME
    container_memory_test
  SRCS
    "internal/container_memory_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::container_memory
    absl::strings
    absl::test_instance_tracker
    gmock_main
)

absl_cc_library(
  NAME
    hash_function_defaults
  HDRS
    "internal/hash_function_defaults.h"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  DEPS
    absl::config
    absl::cord
    absl::hash
    absl::strings
  PUBLIC
)

absl_cc_test(
  NAME
    hash_function_defaults_test
  SRCS
    "internal/hash_function_defaults_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::cord
    absl::cord_test_helpers
    absl::hash_function_defaults
    absl::hash
    absl::random_random
    absl::strings
    gmock_main
)

absl_cc_library(
  NAME
    hash_generator_testing
  HDRS
    "internal/hash_generator_testing.h"
  SRCS
    "internal/hash_generator_testing.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::hash_policy_testing
    absl::memory
    absl::meta
    absl::strings
  TESTONLY
)

absl_cc_library(
  NAME
    hash_policy_testing
  HDRS
    "internal/hash_policy_testing.h"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::hash
    absl::strings
  TESTONLY
)

absl_cc_test(
  NAME
    hash_policy_testing_test
  SRCS
    "internal/hash_policy_testing_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::hash_policy_testing
    gmock_main
)

absl_cc_library(
  NAME
    hash_policy_traits
  HDRS
    "internal/hash_policy_traits.h"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  DEPS
    absl::meta
  PUBLIC
)

absl_cc_test(
  NAME
    hash_policy_traits_test
  SRCS
    "internal/hash_policy_traits_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::hash_policy_traits
    gmock_main
)

absl_cc_library(
  NAME
    hashtablez_sampler
  HDRS
    "internal/hashtablez_sampler.h"
  SRCS
    "internal/hashtablez_sampler.cc"
    "internal/hashtablez_sampler_force_weak_definition.cc"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  DEPS
    absl::base
    absl::exponential_biased
    absl::have_sse
    absl::synchronization
)

absl_cc_test(
  NAME
    hashtablez_sampler_test
  SRCS
    "internal/hashtablez_sampler_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::hashtablez_sampler
    absl::have_sse
    gmock_main
)

absl_cc_library(
  NAME
    hashtable_debug
  HDRS
    "internal/hashtable_debug.h"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  DEPS
    absl::hashtable_debug_hooks
)

absl_cc_library(
  NAME
    hashtable_debug_hooks
  HDRS
    "internal/hashtable_debug_hooks.h"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  DEPS
    absl::config
  PUBLIC
)

absl_cc_library(
  NAME
    have_sse
  HDRS
    "internal/have_sse.h"
  COPTS
    ${ABSL_DEFAULT_COPTS}
)

absl_cc_library(
  NAME
    node_hash_policy
  HDRS
    "internal/node_hash_policy.h"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  DEPS
    absl::config
  PUBLIC
)

absl_cc_test(
  NAME
    node_hash_policy_test
  SRCS
    "internal/node_hash_policy_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::hash_policy_traits
    absl::node_hash_policy
    gmock_main
)

absl_cc_library(
  NAME
    raw_hash_map
  HDRS
    "internal/raw_hash_map.h"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  DEPS
    absl::container_memory
    absl::raw_hash_set
    absl::throw_delegate
  PUBLIC
)

absl_cc_library(
  NAME
    container_common
  HDRS
    "internal/common.h"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  DEPS
    absl::type_traits
)

absl_cc_library(
  NAME
    raw_hash_set
  HDRS
    "internal/raw_hash_set.h"
  SRCS
    "internal/raw_hash_set.cc"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  DEPS
    absl::bits
    absl::compressed_tuple
    absl::config
    absl::container_common
    absl::container_memory
    absl::core_headers
    absl::endian
    absl::hash_policy_traits
    absl::hashtable_debug_hooks
    absl::have_sse
    absl::layout
    absl::memory
    absl::meta
    absl::optional
    absl::utility
    absl::hashtablez_sampler
  PUBLIC
)

absl_cc_test(
  NAME
    raw_hash_set_test
  SRCS
    "internal/raw_hash_set_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::container_memory
    absl::hash_function_defaults
    absl::hash_policy_testing
    absl::hashtable_debug
    absl::raw_hash_set
    absl::base
    absl::core_headers
    absl::raw_logging_internal
    absl::strings
    gmock_main
)

absl_cc_test(
  NAME
    raw_hash_set_allocator_test
  SRCS
    "internal/raw_hash_set_allocator_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::raw_hash_set

=== src/third_party/abseil-cpp/absl/debugging/CMakeLists.txt ===
#
# Copyright 2017 The Abseil Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#      https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

absl_cc_library(
  NAME
    stacktrace
  HDRS
    "stacktrace.h"
    "internal/stacktrace_aarch64-inl.inc"
    "internal/stacktrace_arm-inl.inc"
    "internal/stacktrace_config.h"
    "internal/stacktrace_generic-inl.inc"
    "internal/stacktrace_powerpc-inl.inc"
    "internal/stacktrace_unimplemented-inl.inc"
    "internal/stacktrace_win32-inl.inc"
    "internal/stacktrace_x86-inl.inc"
  SRCS
    "stacktrace.cc"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  DEPS
    absl::debugging_internal
    absl::config
    absl::core_headers
  PUBLIC
)

absl_cc_library(
  NAME
    symbolize
  HDRS
    "symbolize.h"
    "internal/symbolize.h"
  SRCS
    "symbolize.cc"
    "symbolize_elf.inc"
    "symbolize_unimplemented.inc"
    "symbolize_win32.inc"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  LINKOPTS
    ${ABSL_DEFAULT_LINKOPTS}
    $<$<BOOL:${MINGW}>:"dbghelp">
  DEPS
    absl::debugging_internal
    absl::demangle_internal
    absl::base
    absl::config
    absl::core_headers
    absl::dynamic_annotations
    absl::malloc_internal
    absl::raw_logging_internal
  PUBLIC
)

absl_cc_test(
  NAME
    symbolize_test
  SRCS
    "symbolize_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
    $<$<BOOL:${MSVC}>:-Z7>
  LINKOPTS
    $<$<BOOL:${MSVC}>:-DEBUG>
  DEPS
    absl::stack_consumption
    absl::symbolize
    absl::base
    absl::core_headers
    absl::memory
    absl::raw_logging_internal
    gmock
)

absl_cc_library(
  NAME
    examine_stack
  HDRS
    "internal/examine_stack.h"
  SRCS
    "internal/examine_stack.cc"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  DEPS
    absl::stacktrace
    absl::symbolize
    absl::config
    absl::core_headers
    absl::raw_logging_internal
)

absl_cc_library(
  NAME
    failure_signal_handler
  HDRS
    "failure_signal_handler.h"
  SRCS
    "failure_signal_handler.cc"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  DEPS
    absl::examine_stack
    absl::stacktrace
    absl::base
    absl::config
    absl::core_headers
    absl::errno_saver
    absl::raw_logging_internal
  PUBLIC
)

absl_cc_test(
  NAME
    failure_signal_handler_test
  SRCS
    "failure_signal_handler_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::failure_signal_handler
    absl::stacktrace
    absl::symbolize
    absl::strings
    absl::raw_logging_internal
    Threads::Threads
    gmock
)

absl_cc_library(
  NAME
    debugging_internal
  HDRS
    "internal/address_is_readable.h"
    "internal/elf_mem_image.h"
    "internal/vdso_support.h"
  SRCS
    "internal/address_is_readable.cc"
    "internal/elf_mem_image.cc"
    "internal/vdso_support.cc"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  DEPS
    absl::core_headers
    absl::config
    absl::dynamic_annotations
    absl::errno_saver
    absl::raw_logging_internal
)

absl_cc_library(
  NAME
    demangle_internal
  HDRS
    "internal/demangle.h"
  SRCS
    "internal/demangle.cc"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  DEPS
    absl::base
    absl::core_headers
  PUBLIC
)

absl_cc_test(
  NAME
    demangle_test
  SRCS
    "internal/demangle_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::demangle_internal
    absl::stack_consumption
    absl::core_headers
    absl::memory
    absl::raw_logging_internal
    gmock_main
)

absl_cc_library(
  NAME
    leak_check
  HDRS
    "leak_check.h"
  SRCS
    "leak_check.cc"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  DEPS
    absl::config
    absl::core_headers
  PUBLIC
)

absl_cc_library(
  NAME
    leak_check_disable
  SRCS
    "leak_check_disable.cc"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  PUBLIC
)

absl_cc_library(
  NAME
    leak_check_api_enabled_for_testing
  HDRS
    "leak_check.h"
  SRCS
    "leak_check.cc"
  COPTS
    ${ABSL_DEFAULT_COPTS}
    $<$<BOOL:${ABSL_HAVE_LSAN}>:-DLEAK_SANITIZER>
  TESTONLY
)

absl_cc_library(
  NAME
    leak_check_api_disabled_for_testing
  HDRS
    "leak_check.h"
  SRCS
    "leak_check.cc"
  COPTS
    ${ABSL_DEFAULT_COPTS}
    "-ULEAK_SANITIZER"
  TESTONLY
)

absl_cc_test(
  NAME
    leak_check_test
  SRCS
    "leak_check_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
    "$<$<BOOL:${ABSL_HAVE_LSAN}>:-DABSL_EXPECT_LEAK_SANITIZER>"
  LINKOPTS
    "${ABSL_LSAN_LINKOPTS}"
  DEPS
    absl::leak_check_api_enabled_for_testing
    absl::base
    gmock_main
)

absl_cc_test(
  NAME
    leak_check_no_lsan_test
  SRCS
    "leak_check_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
    "-UABSL_EXPECT_LEAK_SANITIZER"
  DEPS
    absl::leak_check_api_disabled_for_testing
    absl::base
    gmock_main
)

absl_cc_test(
  NAME
    disabled_leak_check_test
  SRCS
    "leak_check_fail_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  LINKOPTS
    "${ABSL_LSAN_LINKOPTS}"
  DEPS
    absl::leak_check_api_enabled_for_testing
    absl::leak_check_disable
    absl::base
    absl::raw_logging_internal
    gmock_main
)

absl_cc_library(
  NAME
    stack_consumption
  HDRS
    "internal/stack_consumption.h"
  SRCS
    "internal/stack_consumption.cc"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  DEPS
    absl::config
    absl::core_headers
    absl::raw_logging_internal
  TESTONLY
)

absl_cc_test(
  NAME
    stack_consumption_test
  SRCS
    "internal/stack_consumption_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::stack_consumption
    absl::core_headers
    absl::raw_logging_internal
    gmock_main
)

# component target
absl_cc_library(
  NAME
    debugging
  COPTS
    ${ABSL_DEFAULT_COPTS}
  DEPS
    absl::stacktrace
    absl::leak_check
  PUBLIC
)

=== src/third_party/abseil-cpp/absl/random/CMakeLists.txt ===
#
# Copyright 2019 The Abseil Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#      https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

absl_cc_library(
  NAME
    random_random
  HDRS
    "random.h"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  LINKOPTS
    ${ABSL_DEFAULT_LINKOPTS}
  DEPS
    absl::random_distributions
    absl::random_internal_nonsecure_base
    absl::random_internal_pcg_engine
    absl::random_internal_pool_urbg
    absl::random_internal_randen_engine
    absl::random_seed_sequences
)

absl_cc_library(
  NAME
    random_bit_gen_ref
  HDRS
    "bit_gen_ref.h"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  LINKOPTS
    ${ABSL_DEFAULT_LINKOPTS}
  DEPS
    absl::core_headers
    absl::random_internal_distribution_caller
    absl::random_internal_fast_uniform_bits
    absl::random_internal_mocking_bit_gen_base
    absl::type_traits
)

absl_cc_test(
  NAME
    random_bit_gen_ref_test
  SRCS
    "bit_gen_ref_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  LINKOPTS
    ${ABSL_DEFAULT_LINKOPTS}
  DEPS
    absl::random_bit_gen_ref
    absl::random_random
    absl::random_internal_sequence_urbg
    gmock
    gtest_main
)

# Internal-only target, do not depend on directly.
absl_cc_library(
  NAME
    random_internal_mocking_bit_gen_base
  HDRS
    "internal/mocking_bit_gen_base.h"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  LINKOPTS
    ${ABSL_DEFAULT_LINKOPTS}
  DEPS
    absl::random_random
    absl::strings
)

# Internal-only target, do not depend on directly.
absl_cc_library(
  NAME
    random_internal_mock_overload_set
  HDRS
    "internal/mock_overload_set.h"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  LINKOPTS
    ${ABSL_DEFAULT_LINKOPTS}
  DEPS
    absl::random_mocking_bit_gen
  TESTONLY
)

absl_cc_library(
  NAME
    random_mocking_bit_gen
  HDRS
    "mock_distributions.h"
    "mocking_bit_gen.h"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  LINKOPTS
    ${ABSL_DEFAULT_LINKOPTS}
  DEPS
    absl::flat_hash_map
    absl::raw_logging_internal
    absl::random_distributions
    absl::random_internal_distribution_caller
    absl::random_internal_mocking_bit_gen_base
    absl::random_internal_mock_overload_set
    absl::strings
    absl::span
    absl::type_traits
    absl::utility
    absl::variant
    gmock
    gtest
  TESTONLY
)

absl_cc_test(
  NAME
    random_mock_distributions_test
  SRCS
    "mock_distributions_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  LINKOPTS
    ${ABSL_DEFAULT_LINKOPTS}
  DEPS
    absl::random_mocking_bit_gen
    absl::random_random
    gmock
    gtest_main
)

absl_cc_test(
  NAME
    random_mocking_bit_gen_test
  SRCS
    "mocking_bit_gen_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  LINKOPTS
    ${ABSL_DEFAULT_LINKOPTS}
  DEPS
    absl::random_bit_gen_ref
    absl::random_mocking_bit_gen
    absl::random_random
    gmock
    gtest_main
)

absl_cc_library(
  NAME
    random_distributions
  SRCS
    "discrete_distribution.cc"
    "gaussian_distribution.cc"
  HDRS
    "bernoulli_distribution.h"
    "beta_distribution.h"
    "discrete_distribution.h"
    "distributions.h"
    "exponential_distribution.h"
    "gaussian_distribution.h"
    "log_uniform_int_distribution.h"
    "poisson_distribution.h"
    "uniform_int_distribution.h"
    "uniform_real_distribution.h"
    "zipf_distribution.h"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  LINKOPTS
    ${ABSL_DEFAULT_LINKOPTS}
  DEPS
    absl::base_internal
    absl::config
    absl::core_headers
    absl::random_internal_generate_real
    absl::random_internal_distributions
    absl::random_internal_fast_uniform_bits
    absl::random_internal_fastmath
    absl::random_internal_iostream_state_saver
    absl::random_internal_traits
    absl::random_internal_uniform_helper
    absl::random_internal_wide_multiply
    absl::strings
    absl::span
    absl::type_traits
)

absl_cc_library(
  NAME
    random_seed_gen_exception
  SRCS
    "seed_gen_exception.cc"
  HDRS
    "seed_gen_exception.h"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  LINKOPTS
    ${ABSL_DEFAULT_LINKOPTS}
  DEPS
    absl::config
)

absl_cc_library(
  NAME
    random_seed_sequences
  SRCS
    "seed_sequences.cc"
  HDRS
    "seed_sequences.h"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  LINKOPTS
    ${ABSL_DEFAULT_LINKOPTS}
  DEPS
    absl::inlined_vector
    absl::random_internal_nonsecure_base
    absl::random_internal_pool_urbg
    absl::random_internal_salted_seed_seq
    absl::random_internal_seed_material
    absl::random_seed_gen_exception
    absl::span
)

absl_cc_test(
  NAME
    random_bernoulli_distribution_test
  SRCS
    "bernoulli_distribution_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  LINKOPTS
    ${ABSL_DEFAULT_LINKOPTS}
  DEPS
    absl::random_distributions
    absl::random_random
    absl::random_internal_sequence_urbg
    gmock
    gtest_main
)

absl_cc_test(
  NAME
    random_beta_distribution_test
  SRCS
    "beta_distribution_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  LINKOPTS
    ${ABSL_DEFAULT_LINKOPTS}
  DEPS
    absl::random_distributions
    absl::random_random
    absl::random_internal_distribution_test_util
    absl::random_internal_sequence_urbg
    absl::raw_logging_internal
    absl::strings
    absl::str_format
    gmock
    gtest_main
)

absl_cc_test(
  NAME
    random_distributions_test
  SRCS
    "distributions_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  LINKOPTS
    ${ABSL_DEFAULT_LINKOPTS}
  DEPS
    absl::random_distributions
    absl::random_random
    absl::random_internal_distribution_test_util
    gmock
    gtest_main
)

absl_cc_test(
  NAME
    random_generators_test
  SRCS
    "generators_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  LINKOPTS
    ${ABSL_DEFAULT_LINKOPTS}
    absl::random_distributions
    absl::random_random
    absl::raw_logging_internal
    gmock
    gtest_main
)

absl_cc_test(
  NAME
    random_log_uniform_int_distribution_test
  SRCS
    "log_uniform_int_distribution_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  LINKOPTS
    ${ABSL_DEFAULT_LINKOPTS}
    absl::core_headers
    absl::random_distributions
    absl::random_internal_distribution_test_util
    absl::random_internal_sequence_urbg
    absl::random_random
    absl::raw_logging_internal
    absl::strings
    absl::str_format
    gmock
    gtest_main
)

absl_cc_test(
  NAME
    random_discrete_distribution_test
  SRCS
    "discrete_distribution_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  LINKOPTS
    ${ABSL_DEFAULT_LINKOPTS}
  DEPS
    absl::random_distributions
    absl::random_internal_distribution_test_util
    absl::random_internal_sequence_urbg
    absl::random_random
    absl::raw_logging_internal
    absl::strings
    gmock
    gtest_main
)

absl_cc_test(
  NAME
    random_poisson_distribution_test
  SRCS
    "poisson_distribution_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  LINKOPTS
    ${ABSL_DEFAULT_LINKOPTS}
  DEPS
    absl::random_distributions
    absl::random_random
    absl::core_headers
    absl::flat_hash_map
    absl::random_internal_distribution_test_util
    absl::random_internal_sequence_urbg
    absl::raw_logging_internal
    absl::strings
    absl::str_format
    gmock
    gtest_main
)

absl_cc_test(
  NAME
    random_exponential_distribution_test
  SRCS
    "exponential_distribution_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  LINKOPTS
    ${ABSL_DEFAULT_LINKOPTS}
  DEPS
    absl::core_headers
    absl::random_distributions
    absl::random_internal_distribution_test_util
    absl::random_internal_sequence_urbg
    absl::random_random
    absl::raw_logging_internal
    absl::strings
    absl::str_format
    gmock
    gtest_main
)

absl_cc_test(
  NAME
    random_gaussian_distribution_test
  SRCS
    "gaussian_distribution_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  LINKOPTS
    ${ABSL_DEFAULT_LINKOPTS}
  DEPS
    absl::core_headers
    absl::random_distributions
    absl::random_internal_distribution_test_util
    absl::random_internal_sequence_urbg
    absl::random_random
    absl::raw_logging_internal
    absl::strings
    absl::str_format
    gmock
    gtest_main
)

absl_cc_test(
  NAME
    random_uniform_int_distribution_test
  SRCS
    "uniform_int_distribution_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  LINKOPTS
    ${ABSL_DEFAULT_LINKOPTS}
  DEPS
    absl::random_distributions
    absl::random_internal_distribution_test_util
    absl::random_internal_sequence_urbg
    absl::random_random
    absl::raw_logging_internal
    absl::strings
    gmock
    gtest_main
)

absl_cc_test(
  NAME
    random_uniform_real_distribution_test
  SRCS
    "uniform_real_distribution_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  LINKOPTS
    ${ABSL_DEFAULT_LINKOPTS}
  DEPS
    absl::random_distributions
    absl::random_internal_distribution_test_util
    absl::random_internal_sequence_urbg
    absl::random_random
    absl::strings
    gmock
    gtest_main
)

absl_cc_test(
  NAME
    random_zipf_distribution_test
  SRCS
    "zipf_distribution_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  LINKOPTS
    ${ABSL_DEFAULT_LINKOPTS}
  DEPS
    absl::random_distributions
    absl::random_internal_distribution_test_util
    absl::random_internal_sequence_urbg
    absl::random_random
    absl::raw_logging_internal
    absl::strings
    gmock
    gtest_main
)

absl_cc_test(
  NAME
    random_examples_test
  SRCS
    "examples_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  LINKOPTS
    ${ABSL_DEFAULT_LINKOPTS}
  DEPS
    absl::random_random
    gtest_main
)

absl_cc_test(
  NAME
    random_seed_sequences_test
  SRCS
    "seed_sequences_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  LINKOPTS
    ${ABSL_DEFAULT_LINKOPTS}
  DEPS
    absl::random_seed_sequences
    absl::random_internal_nonsecure_base
    absl::random_random
    gmock
    gtest_main
)

# Internal-only target, do not depend on directly.
absl_cc_library(
  NAME
    random_internal_traits
  HDRS
    "internal/traits.h"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  LINKOPTS
    ${ABSL_DEFAULT_LINKOPTS}
  DEPS
    absl::config
)

# Internal-only target, do not depend on directly.
absl_cc_library(
  NAME
    random_internal_distribution_caller
  HDRS
    "internal/distribution_caller.h"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  LINKOPTS
    ${ABSL_DEFAULT_LINKOPTS}
  DEPS
    absl::config
)

# Internal-only target, do not depend on directly.
absl_cc_library(
  NAME
    random_internal_distributions
  HDRS
    "internal/distributions.h"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  LINKOPTS
    ${ABSL_DEFAULT_LINKOPTS}
  DEPS
    absl::random_internal_distribution_caller
    absl::random_internal_fast_uniform_bits
    absl::random_internal_fastmath
    absl::random_internal_traits
    absl::random_internal_uniform_helper
    absl::span
    absl::strings
    absl::type_traits
)

# Internal-only target, do not depend on directly.
absl_cc_library(
  NAME
    random_internal_fast_uniform_bits
  HDRS
    "internal/fast_uniform_bits.h"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  LINKOPTS
    ${ABSL_DEFAULT_LINKOPTS}
  DEPS
    absl::config
)

# Internal-only target, do not depend on directly.
absl_cc_library(
  NAME
    random_internal_seed_material
  SRCS
    "internal/seed_material.cc"
  HDRS
    "internal/seed_material.h"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  LINKOPTS
    ${ABSL_DEFAULT_LINKOPTS}
    $<$<BOOL:${MINGW}>:"bcrypt">
  DEPS
    absl::core_headers
    absl::optional
    absl::random_internal_fast_uniform_bits
    absl::raw_logging_internal
    absl::span
    absl::strings
)

# Internal-only target, do not depend on directly.
absl_cc_library(
  NAME
    random_internal_pool_urbg
  SRCS
    "internal/pool_urbg.cc"
  HDRS
    "internal/pool_urbg.h"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  LINKOPTS
    ${ABSL_DEFAULT_LINKOPTS}
  DEPS
    absl::base
    absl::config

=== src/third_party/usrsctp/usrsctplib/usrsctplib/CMakeLists.txt ===
#
# Copyright (C) 2015-2015 Oleg Alexeenkov
# Copyright (C) 2015-2019 Felix Weinrank
#
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
# 3. Neither the name of the project nor the names of its contributors
#    may be used to endorse or promote products derived from this software
#    without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE PROJECT AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE PROJECT OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#


#################################################
# INCLUDE MODULES AND SETTINGS
#################################################

set(VERSION "1.0.0")

set(prefix 					${CMAKE_INSTALL_PREFIX})
set(exec_prefix 			${prefix})
set(libdir 					${exec_prefix}/lib)
set(includedir 				${prefix}/include/usrsctp)
set(CMAKE_REQUIRED_INCLUDES ${CMAKE_CURRENT_SOURCE_DIR})
set(CMAKE_MACOSX_RPATH 		1)

add_definitions(-D__Userspace__)
add_definitions(-D__Userspace_os_${CMAKE_SYSTEM_NAME})
add_definitions(-DSCTP_SIMPLE_ALLOCATOR)
add_definitions(-DSCTP_PROCESS_LEVEL_LOCKS)


#################################################
# OS DEPENDENT
#################################################

check_c_compiler_flag(-Wno-address-of-packed-member has_wno_address_of_packet_member)
if (has_wno_address_of_packet_member)
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-address-of-packed-member")
endif ()

if (CMAKE_SYSTEM_NAME MATCHES "Linux")
	add_definitions(-D_GNU_SOURCE)
endif ()

if (CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
	add_definitions(-U__FreeBSD__)
endif ()

if (CMAKE_SYSTEM_NAME MATCHES "Darwin")
	add_definitions(-U__APPLE__)
	add_definitions(-D__APPLE_USE_RFC_2292)
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-deprecated-declarations")
endif ()

if (CMAKE_SYSTEM_NAME MATCHES "DragonFly")
	add_definitions(-U__DragonFly__)
endif ()

if (CMAKE_SYSTEM_NAME MATCHES "NetBSD")
	add_definitions(-U__NetBSD__)
endif ()

if (CMAKE_SYSTEM_NAME MATCHES "OpenBSD")
	add_definitions(-U__OpenBSD__)
endif ()

#################################################
# MISC
#################################################



#################################################
# LIBRARY FILES
#################################################

include_directories(${CMAKE_CURRENT_SOURCE_DIR})

list(APPEND usrsctp_root_headers
	user_atomic.h
	user_environment.h
	user_inpcb.h
	user_ip_icmp.h
	user_ip6_var.h
	user_malloc.h
	user_mbuf.h
	user_queue.h
	user_recv_thread.h
	user_route.h
	user_socketvar.h
	user_uma.h
	usrsctp.h
)

list(APPEND usrsctp_netinet_headers
	netinet/sctp_asconf.h
	netinet/sctp_auth.h
	netinet/sctp_bsd_addr.h
	netinet/sctp_callout.h
	netinet/sctp_constants.h
	netinet/sctp_crc32.h
	netinet/sctp_header.h
	netinet/sctp_indata.h
	netinet/sctp_input.h
	netinet/sctp_lock_userspace.h
	netinet/sctp_os_userspace.h
	netinet/sctp_os.h
	netinet/sctp_output.h
	netinet/sctp_pcb.h
	netinet/sctp_peeloff.h
	netinet/sctp_process_lock.h
	netinet/sctp_sha1.h
	netinet/sctp_structs.h
	netinet/sctp_sysctl.h
	netinet/sctp_timer.h
	netinet/sctp_uio.h
	netinet/sctp_var.h
	netinet/sctputil.h
	netinet/sctp.h
)

list(APPEND usrsctp_netinet6_headers
	netinet6/sctp6_var.h
)

list(APPEND usrsctp_headers
	${usrsctp_root_headers}
	${usrsctp_netinet_headers}
	${usrsctp_netinet6_headers}
)

list(APPEND usrsctp_sources
	netinet/sctp_asconf.c
	netinet/sctp_auth.c
	netinet/sctp_bsd_addr.c
	netinet/sctp_callout.c
	netinet/sctp_cc_functions.c
	netinet/sctp_crc32.c
	netinet/sctp_indata.c
	netinet/sctp_input.c
	netinet/sctp_output.c
	netinet/sctp_pcb.c
	netinet/sctp_peeloff.c
	netinet/sctp_sha1.c
	netinet/sctp_ss_functions.c
	netinet/sctp_sysctl.c
	netinet/sctp_timer.c
	netinet/sctp_userspace.c
	netinet/sctp_usrreq.c
	netinet/sctputil.c
	netinet6/sctp6_usrreq.c
	user_environment.c
	user_mbuf.c
	user_recv_thread.c
	user_socket.c
)

add_library(usrsctp SHARED ${usrsctp_sources} ${usrsctp_headers})
add_library(usrsctp-static STATIC ${usrsctp_sources} ${usrsctp_headers})

target_include_directories(usrsctp PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})
target_include_directories(usrsctp-static PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})

if (WIN32)
	message(STATUS "link library: ws2_32")
	target_link_libraries(usrsctp ws2_32 iphlpapi.lib)
	target_link_libraries(usrsctp-static ws2_32 iphlpapi.lib)
endif ()

set_target_properties(usrsctp-static PROPERTIES OUTPUT_NAME "usrsctp")
set_target_properties(usrsctp PROPERTIES IMPORT_SUFFIX "_import.lib")
set_target_properties(usrsctp PROPERTIES SOVERSION 1 VERSION 1.0.0)

if (NOT DEFINED CMAKE_INSTALL_LIBDIR)
	SET(CMAKE_INSTALL_LIBDIR lib)
endif ()


#################################################
# INSTALL LIBRARY AND HEADER
#################################################

install(TARGETS usrsctp usrsctp-static DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(FILES usrsctp.h DESTINATION include)

=== debian/changelog ===
libtgowt (0~git20210124.be23804+ds-3~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.
  * Refine minimal CMake version in the debian/control file.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Fri, 26 Feb 2021 00:23:28 +0300

libtgowt (0~git20210124.be23804+ds-3) unstable; urgency=medium

  * Mention missing libprotobuf-dev transitive dependency.
  * Move sources requiring SSE2 to separate sublibrary.
  * Define NO_MAIN_THREAD_WRAPPING macro through d/rules. (Closes: #982556)

 -- Nicholas Guriev <guriev-ns@ya.ru>  Fri, 12 Feb 2021 15:53:58 +0300

libtgowt (0~git20210124.be23804+ds-2) unstable; urgency=medium

  * Require yasm only for x86 based platforms.
  * Fix build on armhf due to incorrect usage of DEB_HOST_ARCH_CPU.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Thu, 04 Feb 2021 21:06:34 +0300

libtgowt (0~git20210124.be23804+ds-1) unstable; urgency=medium

  * Update to the latest upstream commit.
  * New debian/watch file for tracking upstream commits.
  * Do rebuilding protobuf headers.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Wed, 03 Feb 2021 14:02:37 +0300

libtgowt (0~git20201218.6eaebec+ds-2) unstable; urgency=medium

  * Fix porting issues on release architectures.
    - Disable NEON extension on armhf
    - Add Avoid-SSE2-on-i386.patch
    - Add Convert-endianness.patch

 -- Nicholas Guriev <guriev-ns@ya.ru>  Thu, 28 Jan 2021 22:07:04 +0300

libtgowt (0~git20201218.6eaebec+ds-1) unstable; urgency=low

  * Initial upload. (Closes: #977606)

 -- Nicholas Guriev <guriev-ns@ya.ru>  Wed, 23 Dec 2020 17:26:25 +0300

=== debian/control ===
Source: libtgowt
Priority: optional
Section: libs
Maintainer: Nicholas Guriev <guriev-ns@ya.ru>
Build-Depends: debhelper-compat (= 13)
Build-Depends-Arch:
 cmake (>= 3.16.0),
 libasound2-dev,
 libavcodec-dev,
 libavformat-dev,
 libavutil-dev,
 libjpeg62-turbo-dev | libjpeg62-dev | libjpeg9-dev,
 libopus-dev,
 libprotobuf-dev,
 libpulse-dev,
 libssl-dev,
 libswresample-dev,
 libswscale-dev,
 protobuf-compiler,
 yasm [any-amd64 any-i386 x32],
Standards-Version: 4.5.1
Rules-Requires-Root: no
Homepage: https://github.com/desktop-app/tg_owt
Vcs-Git: https://salsa.debian.org/debian/libtgowt.git
Vcs-Browser: https://salsa.debian.org/debian/libtgowt

Package: libtgowt-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libavcodec-dev,
 libavformat-dev,
 libavutil-dev,
 libjpeg62-turbo-dev | libjpeg62-dev | libjpeg9-dev,
 libopus-dev,
 libprotobuf-dev,
 libssl-dev,
 libswresample-dev,
 libswscale-dev,
 ${misc:Depends},
Description: telegram related WebRTC fork
 This supporting package contains a reduced fork of WebRTC source code. It is
 primarily needed for build support of video calls in Telegram Desktop. WebRTC
 project, in general, provides applications real-time capabilities that work on
 top of an open standard.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
include /usr/share/dpkg/default.mk

# Do not split first WebRTC thread. This does not matter in Telegram Desktop
# and it seems to not lead to crashes or race conditions. See: https://bugs.debian.org/982556
export DEB_CPPFLAGS_MAINT_APPEND = -DNO_MAIN_THREAD_WRAPPING

%:
	dh $@

TEMP_DIR = debian/tmp
INSTALL_DIR = debian/libtgowt-dev
INCLUDE_DIR = $(INSTALL_DIR)/usr/include/tg_owt

# Do not build the library as shared. That's not supported by upstream and too
# difficult to guarantee binary compatibility of C++ code.
EXTRA_CMAKE_VARIABLES += BUILD_SHARED_LIBS=OFF TG_OWT_USE_PROTOBUF=ON

ifeq ($(DEB_HOST_ARCH_CPU),i386)
# Do not force SSE2 extension. Rely on checking via cpuid.
EXTRA_CMAKE_VARIABLES += TG_OWT_ARCH_X86_FORCE_SSE=OFF
endif

ifeq ($(DEB_HOST_ARCH),armhf)
# WebRTC provides no runtime NEON checking, forbid unconditionally usage.
EXTRA_CMAKE_VARIABLES += TG_OWT_ARCH_ARMV7_USE_NEON=OFF
endif

override_dh_auto_configure:
	dh_auto_configure -- $(EXTRA_CMAKE_VARIABLES:%=-D%)

execute_after_dh_auto_install:
# Cut non UTF-8 bytes off to silence national-encoding Lintian warning. Regex taken from https://stackoverflow.com/a/1401716/5000805
	find $(INCLUDE_DIR) -type f -print0 | xargs -0 perl -pi -e 's/((?:[\x00-\x7F]|[\xC0-\xDF][\x80-\xBF]|[\xE0-\xEF][\x80-\xBF]{2}|[\xF0-\xF7][\x80-\xBF]{3}){1,100})|./$$1/g'
# Comment PACKAGE and related macros to fix package-name-defined-in-config-h Lintian warning.
	find $(INCLUDE_DIR) -name config.h -print0 | xargs -0 sed -i '/\<PACKAGE\(_\|\>\)/s!^\s*#\s*define\s\+!//def!'
# Skip empty directories to fix package-contains-empty-directory Lintian info diagnostic.
	find $(INCLUDE_DIR) -empty -type d -delete

# Download and repack original source code by hand because of uscan(1) does not
# support yet recursive cloning Git repositories. The next script additionally
# invokes tar(1) with options to generate reproducible tarball. You can install
# archiver tool from PyPI: https://pypi.org/project/git-archive-all/
.ONESHELL:
get-orig-source:
	@trap 'rm -rf $(TEMP_DIR)' EXIT ; set -e -u -x
	git clone --depth=1 https://github.com/desktop-app/tg_owt $(TEMP_DIR)/libtgowt.git
	git -C $(TEMP_DIR)/libtgowt.git submodule init
	git -C $(TEMP_DIR)/libtgowt.git submodule update --depth=1
	VERSION=`git -C $(TEMP_DIR)/libtgowt.git log -1 --format=0~git%cd.%h --date=format:%Y%m%d`
	MODIFIED=`git -C $(TEMP_DIR)/libtgowt.git log -1 --format=@%ct`
	git-archive-all -C $(TEMP_DIR)/libtgowt.git --prefix=libtgowt-$$VERSION/ $(TEMP_DIR)/libtgowt.tar
	tar -xf $(TEMP_DIR)/libtgowt.tar -C $(TEMP_DIR)
	rm -r $(TEMP_DIR)/libtgowt-$$VERSION/src/third_party/yasm
	tar --owner=root:0 --group=root:0 --mtime=$$MODIFIED -caf ../libtgowt_$$VERSION+ds.orig.tar.xz -C $(TEMP_DIR) libtgowt-$$VERSION

=== debian/watch ===
# This file is solely designated for tracking new updates. You can't use
# uscan(1) for downloading the latest update, for this run
# the "get-orig-source" target from the debian/rules file.

version=4
opts="mode=git, pretty=0~git%cd.%h, repacksuffix=+ds, dversionmangle=auto" \
  https://github.com/desktop-app/tg_owt heads/master debian false
